=== debian/changelog ===
yabause (0.9.13.1-1) unstable; urgency=medium

  * New upstream bugfix release.

 -- Evgeni Golov <evgeni@debian.org>  Sat, 04 Jan 2014 10:58:24 +0100

yabause (0.9.13-2) unstable; urgency=medium

  * Do not crash settings, if there is no optical drive in the system.
    Patch imported from upstream.
    Closes: #732804
  * Standards-Version: 3.9.5
  * Update debian/copyright to final machine readable format

 -- Evgeni Golov <evgeni@debian.org>  Mon, 23 Dec 2013 16:52:53 +0100

yabause (0.9.13-1) unstable; urgency=low

  * New upstream release.
  * Correct Vcs-* URLs to point to anonscm.debian.org

 -- Evgeni Golov <evgeni@debian.org>  Mon, 15 Jul 2013 22:22:25 +0200
