=== debian/watch ===
version=3
http://sf.net/yabause/yabause-(.*)\.tar\.gz
