## yabause 0.9.14

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,7 +5,7 @@
 set(YAB_PACKAGE yabause)
 set(YAB_VERSION_MAJOR 0)
 set(YAB_VERSION_MINOR 9)
-set(YAB_VERSION_PATCH 13.1)
+set(YAB_VERSION_PATCH 14)
 set(YAB_VERSION "${YAB_VERSION_MAJOR}.${YAB_VERSION_MINOR}.${YAB_VERSION_PATCH}")
 
 set(CPACK_SOURCE_GENERATOR TGZ)
@@ -26,8 +26,10 @@
 	set(CPACK_NSIS_MENU_LINKS yabause.exe;Yabause)
 	set(CPACK_NSIS_URL_INFO_ABOUT "http://yabause.org")
 	set(CPACK_NSIS_COMPRESSOR "/SOLID lzma")
-   	if("${CMAKE_SYSTEM_PROCESSOR}" STREQUAL "x86_64" OR "${CMAKE_SYSTEM_PROCESSOR}" STREQUAL "AMD64")
+	if(${CMAKE_SIZEOF_VOID_P} EQUAL 8)
 		set(CPACK_SYSTEM_NAME "win64")
+		set(CPACK_NSIS_INSTALL_ROOT "$PROGRAMFILES64")
+		set(CPACK_PACKAGE_INSTALL_REGISTRY_KEY "${CPACK_PACKAGE_NAME}${CPACK_PACKAGE_VERSION} (Win64)")
 	endif ()
 endif ()
