=== l10n/CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 project(yabause-l10n)
 
-set(LANGS de es fr it lt nl pt pt_BR sv)
+set(LANGS ar de es fr it lt nl pt pt_BR ru sv zh_CN zh_TW)
 
 if (UNIX AND NOT APPLE)
     foreach(LANG ${LANGS})
