=== src/CMakeLists.txt ===
--- 
+++ 
@@ -2,6 +2,8 @@
 
 include(CheckFunctionExists)
 include(CheckIncludeFile)
+
+set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_SOURCE_DIR}/CMakeTests)
 
 set(yabause_SOURCES
 	bios.c
@@ -12,7 +14,7 @@
 	japmodem.c netlink.c
 	osdcore.c
 	peripheral.c profile.c
-	scu.c sh2core.c sh2d.c sh2idle.c sh2int.c sh2trace.c smpc.c snddummy.c
+	scu.c sh2core.c sh2d.c sh2iasm.c sh2idle.c sh2int.c sh2trace.c smpc.c snddummy.c
 	titan/titan.c
 	vdp1.c vdp2.c vdp2debug.c vidogl.c vidshared.c vidsoft.c
 	yabause.c ygl.c yglshader.c)
@@ -135,14 +137,24 @@
 # SDL
 option(YAB_WANT_SDL "use SDL cores if available" ON)
 if (YAB_WANT_SDL)
-	include(FindSDL)
-	if (SDL_FOUND)
+	include(FindSDL2 OPTIONAL)
+
+	if (SDL2_FOUND)
+		include_directories(${SDL2_INCLUDE_DIR})
+		set(YABAUSE_LIBRARIES ${YABAUSE_LIBRARIES} ${SDL2_LIBRARY})
+	else()
+		include(FindSDL)
+		if (SDL_FOUND)
+			include_directories(${SDL_INCLUDE_DIR})
+			set(YABAUSE_LIBRARIES ${YABAUSE_LIBRARIES} ${SDL_LIBRARY})
+		endif()
+	endif()
+
+	if (SDL_FOUND OR SDL2_FOUND)
 		add_definitions(-DHAVE_LIBSDL=1)
-		include_directories(${SDL_INCLUDE_DIR})
 		set(yabause_SOURCES ${yabause_SOURCES} persdljoy.c sndsdl.c)
-		set(YABAUSE_LIBRARIES ${YABAUSE_LIBRARIES} ${SDL_LIBRARY})
-	endif (SDL_FOUND)
-endif (YAB_WANT_SDL)
+	endif()
+endif()
 
 # OpenAL
 option(YAB_WANT_OPENAL "use OpenAL sound core if available" ON)
@@ -340,9 +352,3 @@
 			enable_language(ASM-ATT)
 			set(yabause_SOURCES ${yabause_SOURCES}
 				sh2_dynarec/sh2_dynarec.c sh2_dynarec/linkage_arm.s)
-			set_source_files_properties(sh2_dynarec/sh2_dynarec.c PROPERTIES COMPILE_FLAGS "-Wno-pointer-to-int-cast -Wno-int-to-pointer-cast")
-			add_definitions(-DSH2_DYNAREC=1 -DHAVE_ARMv6=1 -DHAVE_ARMv7=1)
-		endif("${CMAKE_SYSTEM_PROCESSOR}" STREQUAL "armv7l")
-		if (ANDROID)
-			enable_language(ASM-ATT)
-			set(yabause_SOURCES ${yabause_SOURCES}
