=== src/qt/CMakeLists.txt ===
--- 
+++ 
@@ -2,12 +2,10 @@
 
 yab_port_start()
 
-option(YAB_USE_QT5 "Use Qt 5 if available." off)
-
-if(YAB_USE_QT5) 
-	find_package(Qt5Widgets)
-
-	add_definitions(-DUSE_QT5=1)
+find_package(Qt5 COMPONENTS Widgets)
+
+if(Qt5_FOUND) 
+	message(STATUS "Qt5 Found")
 
 	if( YAB_WANT_OPENGL )
         	find_package(Qt5OpenGL)
@@ -19,11 +17,11 @@
 	if (WIN32)
         	find_package(Qt5Core)
 	endif()
-else(YAB_USE_QT5) 
+else() 
 	find_package(Qt4)
 
 	if (NOT QT4_FOUND)
-		message(STATUS "NO QT4_FOUND")
+		message(STATUS "NO QT4_FOUND OR Qt5_FOUND")
 		return()
 	endif (NOT QT4_FOUND)
 
@@ -38,7 +36,7 @@
 
 	# dunno what it does exactly ... but seem required
 	include( ${QT_USE_FILE} )
-endif(YAB_USE_QT5) 
+endif() 
 
 # qt resources file
 set( yabause_qt_RESOURCES resources/resources.qrc )
@@ -72,6 +70,7 @@
 	ui/UIPortManager.ui
 	ui/UIPadSetting.ui 
 	ui/UI3DControlPadSetting.ui 
+	ui/UIGunSetting.ui
 	ui/UIMouseSetting.ui 
     ui/UIDebugCPU.ui
     ui/UIDebugSCSP.ui
@@ -105,6 +104,7 @@
 	ui/UIControllerSetting.h
 	ui/UIPadSetting.h
 	ui/UI3DControlPadSetting.h
+	ui/UIGunSetting.h
 	ui/UIMouseSetting.h
 	ui/UIShortcutManager.h
     ui/UIDebugCPU.h
@@ -145,6 +145,7 @@
 	ui/UIControllerSetting.cpp
 	ui/UIPadSetting.cpp
 	ui/UI3DControlPadSetting.cpp
+	ui/UIGunSetting.cpp
 	ui/UIMouseSetting.cpp
 	ui/UIShortcutManager.cpp
     ui/UIDebugCPU.cpp
@@ -172,15 +173,15 @@
 	set( yabause_qt_SOURCES ${yabause_qt_SOURCES} YabauseSoftGL.cpp )
 endif()
 
-if(YAB_USE_QT5) 
+if(Qt5_FOUND) 
 	QT5_ADD_RESOURCES( yabause_qt_RCC_RESOURCES ${yabause_qt_RESOURCES} )
 	QT5_WRAP_UI( yabause_qt_UI_FORMS ${yabause_qt_FORMS} )
 	QT5_WRAP_CPP( yabause_qt_MOC_SOURCES ${yabause_qt_MOC_HEADERS} )
-else(YAB_USE_QT5) 
+else() 
 	QT4_ADD_RESOURCES( yabause_qt_RCC_RESOURCES ${yabause_qt_RESOURCES} )
 	QT4_WRAP_UI( yabause_qt_UI_FORMS ${yabause_qt_FORMS} )
 	QT4_WRAP_CPP( yabause_qt_MOC_SOURCES ${yabause_qt_MOC_HEADERS} )
-endif(YAB_USE_QT5) 
+endif() 
 
 set( yabause_qt_SOURCES ${yabause_qt_SOURCES} resources/icons/yabause.icns )
 set_source_files_properties( resources/icons/yabause.icns PROPERTIES MACOSX_PACKAGE_LOCATION Resources )
@@ -195,14 +196,14 @@
 	${yabause_qt_UI_FORMS}
 	${yabause_qt_MOC_SOURCES} )
 
-if (YAB_USE_QT5)
+if (Qt5_FOUND)
 include_directories(
 	.
 	${CMAKE_CURRENT_BINARY_DIR}
 	${CMAKE_CURRENT_SOURCE_DIR}/ui
 	${Qt5Widgets_INCLUDE_DIRS}
 	${Qt5OpenGL_INCLUDE_DIRS} )
-else(YAB_USE_QT5)
+else()
 include_directories(
 	.
 	${CMAKE_CURRENT_BINARY_DIR}
@@ -211,7 +212,7 @@
 	${QT_QTCORE_INCLUDE_DIR}
 	${QT_QTGUI_INCLUDE_DIR}
 	${QT_QTOPENGL_INCLUDE_DIR} )
-endif(YAB_USE_QT5)
+endif()
 
 # APPLE // not necessary mac os x, but i don't care ;)
 if (APPLE)
@@ -228,11 +229,11 @@
 target_link_libraries( yabause-qt ${PORT_LIBRARIES} )
 target_link_libraries( yabause-qt ${yabause_qt_windows_LIBRARIES} )
 target_link_libraries( yabause-qt ${yabause_qt_macosx_LIBRARIES} )
-if (YAB_USE_QT5)
+if (Qt5_FOUND)
 	target_link_libraries( yabause-qt ${Qt5Widgets_LIBRARIES} ${Qt5OpenGL_LIBRARIES} ${Qt5Core_QTMAIN_LIBRARIES} ${Qt5Network_LIBRARIES} )
-else(YAB_USE_QT5)
+else()
 	target_link_libraries( yabause-qt ${QT_LIBRARIES} )
-endif(YAB_USE_QT5)
+endif()
 
 yab_port_success(yabause-qt)
 configure_file(yabause.desktop.in ${YAB_PORT_NAME}.desktop)
@@ -248,10 +249,15 @@
 			DESTINATION "."
 			FILES_MATCHING PATTERN "SDL*.dll")
 	endif ()
-	if(YAB_USE_QT5) 
+	if(Qt5_FOUND) 
 		install(FILES ${QT_BINARY_DIR}/Qt5Core.dll DESTINATION ".")
 		install(FILES ${QT_BINARY_DIR}/Qt5Gui.dll DESTINATION ".")
 		install(FILES ${QT_BINARY_DIR}/Qt5OpenGL.dll DESTINATION ".")
+		install(FILES ${QT_BINARY_DIR}/Qt5Widgets.dll DESTINATION ".")
+		install(FILES ${QT_BINARY_DIR}/icudt51.dll DESTINATION ".")
+		install(FILES ${QT_BINARY_DIR}/icuin51.dll DESTINATION ".")
+		install(FILES ${QT_BINARY_DIR}/icuuc51.dll DESTINATION ".")
+		install(FILES ${QT_BINARY_DIR}/../plugins/platforms/qwindows.dll DESTINATION "plugins/platforms")
 	else()
 		install(FILES ${QT_BINARY_DIR}/QtCore4.dll DESTINATION ".")
 		install(FILES ${QT_BINARY_DIR}/QtGui4.dll DESTINATION ".")
@@ -269,7 +275,7 @@
 		if("${CMAKE_SYSTEM_PROCESSOR}" STREQUAL "x86_64" OR "${CMAKE_SYSTEM_PROCESSOR}" STREQUAL "AMD64")
 			install(DIRECTORY ${Mingw_Path}/
 				DESTINATION "."
-				FILES_MATCHING PATTERN "libgcc_s_*.dll" PATTERN "libstdc++-*.dll")
+				FILES_MATCHING PATTERN "libgcc_s_*.dll" PATTERN "libstdc++-*.dll" PATTERN "libwinpthread-*.dll")
 		else()
 			install(DIRECTORY ${Mingw_Path}/
 				DESTINATION "."
