=== debian/changelog ===
yabause (0.9.14-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Search for gdkglext-config.h in the new location.
    (Closes: #870304)

 -- Adrian Bunk <bunk@debian.org>  Tue, 29 Aug 2017 15:49:16 +0300

yabause (0.9.14-2) unstable; urgency=medium

  * Build without dynarec, as this fails with PIE.
    Closes: #837582

 -- Evgeni Golov <evgeni@debian.org>  Sat, 29 Oct 2016 09:53:24 +0200

yabause (0.9.14-1) unstable; urgency=medium

  * New upstream release
  * Add myself to Uploaders
  * Add menu files
    Closes: #726907
  * Standards-Version: 3.9.6

 -- Matt Arnold <adeodatus@sdf.org>  Fri, 29 May 2015 22:39:31 -0400
