=== debian/control ===
--- 
+++ 
@@ -2,13 +2,13 @@
 Section: otherosfs
 Priority: optional
 Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
-Uploaders: Evgeni Golov <evgeni@debian.org>
+Uploaders: Evgeni Golov <evgeni@debian.org>, Matt Arnold <adeodatus@sdf.org>
 Build-Depends: debhelper (>= 9), cmake, pkg-config,
  libgl1-mesa-dev | libgl-dev, freeglut3-dev | libglut-dev, libglu1-mesa-dev | libglu-dev,
  libsdl1.2-dev, libglib2.0-dev, libgtk2.0-dev, libgtkglext1-dev,
  libqt4-dev, libqt4-opengl-dev, libmini18n-dev, libopenal-dev,
  dh-autoreconf
-Standards-Version: 3.9.5
+Standards-Version: 3.9.6
 Homepage: http://yabause.org
 Vcs-Svn: svn://anonscm.debian.org/pkg-games/packages/trunk/yabause/
 Vcs-Browser: http://anonscm.debian.org/viewvc/pkg-games/packages/trunk/yabause/
