=== debian/rules ===
--- 
+++ 
@@ -12,4 +12,4 @@
 	dh $@
 
 override_dh_auto_configure:
-	dh_auto_configure -- -DYAB_MULTIBUILD=1 -DYAB_OPTIMIZATION=""
+	dh_auto_configure -- -DYAB_MULTIBUILD=1 -DYAB_OPTIMIZATION="" -DSH2_DYNAREC=OFF
